/*

 C O M P I L E R 96 S O F T W A R E   

                                                                        
  REGTABLE.H                                                            
                                                                        
  #include "REGTABLE.H"                                                 
                                                                        
  1996 Compiler SoftWare.                                               
  Leer el artculo n 24 o la documentacin del programa VGAREGS.TXT     
                                                                      
:-)
*/

#include <stdio.h>                                 /* FILE I/O ops */

#define ATTR                    0x3c0
#define MISC                    0x3c2
#define VGAENABLE               0x3c3
#define SEQU                    0x3c4
#define GRAC                    0x3ce
#define CRTC                    0x3d4
#define STATUS                  0x3da
#define CHIPSTECH               0x3d6


/* Estructuras de datos internas: */

struct Register {
       int Port;
       char Index;
       unsigned char Value;
       char Activated;              /* 0 = no, 1 = s */
		};

struct Table {
       struct Register Reg[29];      /* slo 29 registros son importantes */
	     } RegTable;                    /* ver vgaregs.txt */
/*

                       DECLARACIONES DE FUNCIONES                     

*/

void UnProtCRTC( void );
unsigned char RegIn( int, char );
void RegOut( int, char, unsigned char );

void InitRegTable( void );
void OutRegTable( void );
void InRegTable( void );
char LoadRegTable( char * );

/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
/* Funciones para no usar dos.h : */
/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/

void OutPb( int , unsigned char );              
void OutPw( int , int );                        
unsigned char InPb( int );                   
unsigned int InPw( int );                    



/*

 InitRegTable();                                                      
                                                                      
 Inicializa la estructura RegTable para que se puedan usar las dems  
 funciones. HAY QUE ponerlo al principio del programa antes de usar   
 cualquier funcin. ( Slo una vez y al principio ).                  
                                                                      
 Simplemente es para inicializar los valores iniciales de la tabla,   
 poniendo los n de puertos y de ndices, ya que en C no se pueden    
 poner valores iniciales a las tablas si no es as.                   
                                                                      

*/

void InitRegTable( void )
{
char f;
 
 RegTable.Reg[ 0].Port = 0x3c0;
 RegTable.Reg[ 1].Port = 0x3c0; RegTable.Reg[ 2].Port = 0x3c0;
 RegTable.Reg[ 3].Port = 0x3c0; RegTable.Reg[ 4].Port = 0x3c0;
 RegTable.Reg[ 5].Port = 0x3c2; RegTable.Reg[ 6].Port = 0x3c4;
 RegTable.Reg[ 7].Port = 0x3c4; RegTable.Reg[ 8].Port = 0x3c4;
 RegTable.Reg[ 9].Port = 0x3ce; RegTable.Reg[10].Port = 0x3ce;
 RegTable.Reg[11].Port = 0x3d4; RegTable.Reg[12].Port = 0x3d4;
 RegTable.Reg[13].Port = 0x3d4; RegTable.Reg[14].Port = 0x3d4;
 RegTable.Reg[15].Port = 0x3d4; RegTable.Reg[16].Port = 0x3d4;
 RegTable.Reg[17].Port = 0x3d4; RegTable.Reg[18].Port = 0x3d4;
 RegTable.Reg[19].Port = 0x3d4; RegTable.Reg[20].Port = 0x3d4;
 RegTable.Reg[21].Port = 0x3d4; RegTable.Reg[22].Port = 0x3d4;
 RegTable.Reg[23].Port = 0x3d4; RegTable.Reg[24].Port = 0x3d4;
 RegTable.Reg[25].Port = 0x3d4; RegTable.Reg[26].Port = 0x3d4;
 RegTable.Reg[27].Port = 0x3d4; RegTable.Reg[28].Port = 0x3d4;

 RegTable.Reg[ 0].Index = 0x10;
 RegTable.Reg[ 1].Index = 0x11; RegTable.Reg[ 2].Index = 0x12;
 RegTable.Reg[ 3].Index = 0x13; RegTable.Reg[ 4].Index = 0x14;
 RegTable.Reg[ 5].Index =  0 ; RegTable.Reg[ 6].Index =  1 ;
 RegTable.Reg[ 7].Index =  3 ; RegTable.Reg[ 8].Index =  4 ;
 RegTable.Reg[ 9].Index =  5 ; RegTable.Reg[10].Index =  6 ;
 RegTable.Reg[11].Index =  0 ; RegTable.Reg[12].Index =  1 ;
 RegTable.Reg[13].Index =  2 ; RegTable.Reg[14].Index =  3 ;
 RegTable.Reg[15].Index =  4 ; RegTable.Reg[16].Index =  5 ;
 RegTable.Reg[17].Index =  6 ; RegTable.Reg[18].Index =  7 ;
 RegTable.Reg[19].Index =  8 ; RegTable.Reg[20].Index =  9 ;
 RegTable.Reg[21].Index = 0x10; RegTable.Reg[22].Index = 0x11;
 RegTable.Reg[23].Index = 0x12; RegTable.Reg[24].Index = 0x13;
 RegTable.Reg[25].Index = 0x14; RegTable.Reg[26].Index = 0x15;
 RegTable.Reg[27].Index = 0x16; RegTable.Reg[28].Index = 0x17;


 for(f=0; f<29; f++) RegTable.Reg[f].Activated = 1;

}

/*

 OutRegTable();                                                       
                                                                      
 Manda los valores que contiene la tabla RegTable hacia los puertos   
 VGA para modificar los valores de los registros usando RegOut();     
                                                                      

*/

void OutRegTable( void )
{
  char f;
   UnProtCRTC();
   for( f=0; f<29; f++ )
    {
     if( RegTable.Reg[f].Activated == 1 )       /* si est activado */
      { 
	RegOut( RegTable.Reg[f].Port, RegTable.Reg[f].Index, 
		RegTable.Reg[f].Value );
      }
    }

   InPb( STATUS );
   OutPb( ATTR, 0x20 );         /* permitir escritura a pantalla */

}

/*

 InRegTable();                                                        
                                                                      
 Carga los valores de la tabla RegTable desde los puertos             
 VGA para leer los valores de los registros usando RegIn();           
                                                                      

*/

void InRegTable( void )
{
  char f;
   for( f=0; f<29; f++ )
    {
      RegTable.Reg[f].Value = RegIn( RegTable.Reg[f].Port, 
				     RegTable.Reg[f].Index );
    }
   
   InPb( STATUS );
   OutPb( ATTR, 0x20 );         /* permitir escritura a pantalla */
   
}


/*

 LoadRegTable();                                                      
                                                                      
 Carga los valores desde el fichero .unc que se le especifica, gene-  
 rado mediante VGAREGS.                                               
                                                                      
 DEVUELVE:                                                            
   0 = Error cargando el archivo (no existe o no est en el direct. ) 
   1 = Archivo cargado con xito.                                     
                                                                      

*/

char LoadRegTable( char *filename )
{
 FILE *fp;
 char f;
 fp = fopen( filename, "rb" );
  if( fp==NULL ) return(0);

  InitRegTable();

 for( f=0; f<29; f++ )
 {
    RegTable.Reg[f].Activated = fgetc(fp);      /*activado*/
    RegTable.Reg[f].Value     = fgetc(fp);      /* valor  */
 }
 return(1);
}

/*

 SaveRegTable();                                                      
                                                                      
 Salva los valores al fichero .unc que se le especifica, desde la ta- 
 bla de registros que hay en memoria (RegTable).                      
                                                                      
 DEVUELVE:                                                            
   0 = Error salvando el archivo (no existe o no est en el direct. ) 
   1 = Archivo salvado con xito.                                     
                                                                      

*/

char SaveRegTable( char *filename )
{
 FILE *fp;
 char f;
 fp = fopen( filename, "wb" );
  if( fp==NULL ) return(0);

  InitRegTable();

 for( f=0; f<29; f++ )
 {
     fputc(RegTable.Reg[f].Activated,fp);      /*activado*/
     fputc(RegTable.Reg[f].Value    ,fp);      /* valor  */
 }
 return(1);
}

/*

 RegIn();                                                             
                                                                      
 Devuelve el valor que contiene el registro especificado.             

*/

unsigned char RegIn( int Controlador, char index )
{
 unsigned char valor;

  switch ( Controlador )
   {
      case MISC:
	      valor = InPb(0x3cc);  
	      break;
		      /* 0x3c2 es de escritura y 0x3cc de lectura */

      case ATTR:                           
	      InPb(STATUS);   /* reseteamos el flip-flop */
				      /* el ndice *DEBE* tener activado el */
				      /* bit 5. ( p. ej. sumndole 32 ); */
	      OutPb(ATTR, index);
	      valor = InPb(ATTR+1);
	      break;

      case SEQU:
      case GRAC:
      case CRTC:
      case CHIPSTECH:
	      OutPb(Controlador, index);     /* las 3 son iguales */
	      valor = InPb(Controlador+1);
	      break;

      case VGAENABLE:
      default:                      
	      valor = InPb(Controlador);     /* resto de puertos */
	      break;
   } /* fin de switch */

 InPb( STATUS );              /* (faltaba) */
 OutPb( ATTR, 0x20 );         /* permitir escritura a pantalla */
 return(valor);        /* devolvemos el valor */
}



/*

 RegOut();                                                            
                                                                      
 Escribe el valor "valor" en el registro especificado.                

*/

void RegOut( int Controlador, char index, unsigned char valor )
{
  switch (Controlador)
    {
      case ATTR:
	   InPb(STATUS);           /* resetear flip-flop */
	   OutPb(ATTR, index);
	   OutPb(ATTR, valor);  /* hecho ... */
	   break;

      case SEQU:
	   if (index == 1)                 /* este es el caso ms extrao */
	    {
	     OutPw(SEQU, 0x0100);           /* resetear el secuenc. */
	     OutPw(SEQU, valor<<8 | 1);     /* enviar valor */ 
	     OutPw(SEQU, 0x0300);
	     break;
	    };
      case GRAC:
      case CRTC:
      case CHIPSTECH:
	   OutPw( Controlador , index | valor<<8);
	   break;

      case MISC:
      case VGAENABLE:
      default:
	   OutPb(Controlador, valor);
	   break;
    } /* fin de switch */

    InPb( STATUS );              /* (faltaba) */
    OutPb( ATTR, 0x20 );         /* permitir escritura a pantalla */
}


/*

                    FUNCIONES DE PUERTOS MS-DOS                       

*/


/*

 InPb( puerto );                                                      
 Lee del puerto "puerto" y devuelve el valor que tiene. ( 1 byte ).   

*/

unsigned char InPb( int port )
{
asm {
	mov dx , [port]
	in al , dx
    }
return ( _AL );
}

/*

 InPw( puerto );                                                      
 Lee del puerto "puerto" y devuelve el valor que tiene. ( 1 word ).   

*/

unsigned int InPw( int port )
{
asm {
	mov dx , [port]
	in ax , dx
    }
return ( _AX );
}


/*

 OutPb( puerto, valor );                                              
 Escribe el byte valor en el puerto "puerto".                         

*/

void OutPb ( int port, unsigned char dato )
{
asm {
	mov dx , [port]
	mov al , [dato]
	out dx , al
    }
}

/*

 OutPw( puerto, valor );                                              
 Escribe el word valor en el puerto "puerto".                         

*/

void OutPw ( int port, int dato )
{
asm {
	mov dx , [port]
	mov ax , [dato]
	out dx , ax
    }
}

/*

 UnProtCRTC();                                                        
                                                                      
 Desprotege el CRTC para poder modificar los registros que controla.  
 Ver registro 11h en la tabla de registros de artculo, CRTC bit 7.   
                                                                      

*/

void UnProtCRTC( void )
{
 int v ;
	OutPb( CRTC, 0x11 );                     /* ndice = 11h */
	v = InPb( CRTC + 1 );                    /* 3d4h */
	v = v & 0x7F;                            /* bit 7 = 0 */
	OutPb( CRTC, 0x11 );                     /* ndice = 11h */
	OutPw( CRTC, 0x11 | ( v << 8 ) );        /* desproteger */
}

